 comment*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
             
                     Morse Transmitter Custom Control	
                          
                          2005 by Shaka_Zulu
                         
        -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*
    
    
    .586
    .model flat,stdcall
    option casemap:none
    


    
    include windows.inc
    include kernel32.inc
    include user32.inc
    include gdi32.inc
    include comdlg32.inc
    include oleaut32.inc
    include advapi32.inc
    

    
    includelib kernel32.lib
    includelib user32.lib
    includelib gdi32.lib
    includelib comdlg32.lib
    includelib oleaut32.lib
    includelib advapi32.lib
    
    CtrlProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
    RegClass PROTO :DWORD
    UpdateBitmap PROTO :DWORD,:BOOL
    PlayCode	PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
    LoadText PROTO :DWORD,:DWORD
    fmanip PROTO :DWORD,:DWORD,:DWORD
    LoadFile PROTO :DWORD,:DWORD
    SaveFile PROTO :DWORD,:DWORD
    
    include Morse_Transmitter.inc
    include morse_code.asm
    include file_i_o.asm
    include file_assoc.asm
    
    .const
    IDB_BMP1 equ 700
    IDB_BMP2 equ 701
    
    DEF_TONE equ 700
    DEF_PAUSE equ 25
    DEF_SHORT equ 50
    DEF_LONG equ 150
    DEF_CHARS equ 120
    DEF_NUMB equ 90
    
    ;--file manip. flags--
    flag_open equ 1
    flag_save equ 2
    flag_saveas equ 3
    
    
    .data?
    
    hInstance HINSTANCE ?
   	hBmp  HBITMAP ?
   	hBmp2 HBITMAP ?
   	bm BITMAP <>
   	bm2 BITMAP <>
   	KeyCode DWORD ?
   	
   	.data
   	
   	CtrlClass db "Morse_Transmitter",0
   	Module db "Morse_Transmitter.dll",0
   	
   	tone 			dd DEF_TONE		;
   	short_sound 	dd DEF_SHORT	;
   	long_sound 		dd DEF_LONG		; initializing with the 
   	p 				dd DEF_PAUSE	;	default values
   	chars_per_min 	dd DEF_CHARS	;
   	numbers_per_min dd DEF_NUMB		;
   	
   	
   	
    enabled BOOL TRUE
    

       	
   	.code
   	start:
   	
DllMain PROC hInstDll:HINSTANCE,reason1:DWORD,reserved1:DWORD

    push hInstDll
    pop hInstance
	.if reason1==DLL_PROCESS_ATTACH
	
		
		invoke RegClass,hInstDll
		ret
	
	.elseif reason1 == DLL_PROCESS_DETACH
		
		invoke UnregisterClass,addr CtrlClass,hInstDll
		invoke DeleteObject,hBmp
		invoke DeleteObject,hBmp2
		
	.endif	

	ret
DllMain ENDP

RegClass PROC hInstDll:HINSTANCE

		LOCAL wc:WNDCLASSEX
		
			mov wc.cbClsExtra,2
			mov wc.cbSize,sizeof(WNDCLASSEX)
			mov wc.cbWndExtra,0
			mov wc.hbrBackground,COLOR_WINDOWTEXT
			invoke LoadCursor,0,IDC_ARROW
			mov wc.hCursor,eax
			mov wc.hIcon,NULL
			mov wc.hIconSm,NULL
			invoke GetModuleHandle,NULL
			mov wc.hInstance,eax
			mov wc.lpfnWndProc,offset CtrlProc
			mov wc.lpszClassName,offset CtrlClass
			mov wc.lpszMenuName,NULL
			mov wc.style,0
			
			invoke RegisterClassEx,addr wc
			
			.if(eax != 0)
					
				mov eax,TRUE
				ret
				
			.endif
		mov eax,FALSE	
	ret
RegClass ENDP

CtrlProc PROC hwnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

		LOCAL ps:PAINTSTRUCT
		LOCAL hdc:HDC
		LOCAL hMemDC:HDC
		LOCAL rect:RECT
		LOCAL crs :CREATESTRUCT
		LOCAL mulop :DWORD

			
			.if uMsg == WM_CREATE
					
				invoke FileAssoc
				
				mov ebx,lParam
				invoke LoadBitmap,hInstance,IDB_BMP1
				mov hBmp,eax
				invoke LoadBitmap,hInstance,IDB_BMP2
				mov hBmp2,eax
				
				invoke GetObject,hBmp,sizeof BITMAP,addr bm
				mov eax,bm.bmWidth
				add eax,14
				mov edx,bm.bmHeight
				add edx,12
				
				invoke MoveWindow,hwnd,CREATESTRUCT.x[ebx],CREATESTRUCT.y[ebx],eax,edx,TRUE
				invoke SetFocus,hwnd
				
				
			.elseif uMsg == WM_PAINT
					
				invoke BeginPaint,hwnd,addr ps
				mov hdc,eax
				invoke CreateCompatibleDC,hdc
				mov hMemDC,eax
				.if enabled == TRUE
				invoke SelectObject,hMemDC,hBmp
				.elseif enabled == FALSE
				invoke SelectObject,hMemDC,hBmp2
				.endif
				invoke GetClientRect,hwnd,addr rect
				invoke BitBlt,hdc,5,5,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY
				invoke DeleteDC,hMemDC
				invoke EndPaint,hwnd,addr ps
				
				
				
			.elseif uMsg == WM_LBUTTONDOWN
					
				invoke SetFocus,hwnd
				.if enabled == TRUE
						
					invoke UpdateBitmap,hwnd,FALSE
					mov enabled,FALSE
					
				.elseif enabled == FALSE
						
					invoke UpdateBitmap,hwnd,TRUE
					mov enabled,TRUE
				.endif
					
					
			.elseif uMsg == WM_KILLFOCUS || uMsg == MC_MUTE
						
					invoke UpdateBitmap,hwnd,FALSE
					mov enabled,FALSE
					
			.elseif uMsg == WM_RBUTTONDOWN 
					
				invoke SetFocus,hwnd
				
			.elseif uMsg == MC_CHAR || uMsg ==WM_CHAR
					
				mov eax,wParam
				and eax,0ffffh
				mov KeyCode,eax
				
				.if enabled == TRUE
						
					invoke PlayCode,wParam,p,tone,short_sound,long_sound
					
				 .endif
				
			.elseif uMsg == MC_DECREASE	
							
				.if chars_per_min <= 30
						
					mov chars_per_min,30
					ret
					
				.endif	
				
				.if numbers_per_min <=10
						
					mov numbers_per_min,10
					ret
					
				.endif
				
				fild numbers_per_min
				fild wParam
				fsub
				fistp numbers_per_min
				fild chars_per_min
				fild wParam
				fsub
				fistp chars_per_min
					
					
				fild short_sound
				fild wParam
				fadd
				fistp short_sound
				fild short_sound
				mov mulop,3
				fild mulop
				fmul
				fistp long_sound
				fild p
				fild wParam
				fadd
				fistp p
				
				invoke SetFocus,hwnd
				
			.elseif uMsg == MC_INCREASE
					
				mov eax,short_sound
					.if eax <= 20h
								
						mov eax,FALSE
						ret
								
					.endif
					
					fild numbers_per_min
					fild wParam
					fadd
					fistp numbers_per_min
					fild chars_per_min
					fild wParam ;the increment (the inc. is equal of the ch/min change!)
					fadd
					fistp chars_per_min
					
					;--------
					fild short_sound
					fild wParam
					fsub
					fistp short_sound
					fild short_sound
					mov mulop,3
					fild mulop
					fmul
					fistp long_sound
					fild p
					fild wParam
					fsub
					fistp p
					exit:
					
					
			.elseif uMsg == MC_TONEUP
					
				fild tone
				fild wParam
				fadd
				fistp tone
				
			.elseif uMsg == MC_TONEDOWN
					
				.if tone <= 0
						
					mov tone,0
					ret
					
				.endif
				
				fild tone
				fild wParam
				fsub
				fistp tone
				
			.elseif uMsg == MC_GETTONE
					
				mov eax,tone
				ret
					
			.elseif uMsg == MC_GETSPEED
					
				.if wParam == 1
						
					mov eax,chars_per_min
					ret
					
				.endif
		
				.if lParam == 1
						
					mov eax,numbers_per_min
					ret
					
				.endif
					
					
			.elseif uMsg == MC_AUTOTRANSMITTER
					
				invoke LoadText,hwnd,wParam
				
			.elseif uMsg == MC_OPEN
					
				push hBmp
				push hBmp2
				invoke fmanip,wParam,lParam,flag_open
				pop hBmp2
				pop hBmp
				invoke UpdateWindow,hwnd
				ret
				
			.elseif uMsg == MC_SAVE
					
				invoke fmanip,wParam,lParam,flag_save
				
			.elseif uMsg == MC_SAVEAS
					
				invoke fmanip,wParam,lParam,flag_saveas
				
			.endif
			
		invoke DefWindowProc,hwnd,uMsg,wParam,lParam
	ret
CtrlProc ENDP

UpdateBitmap PROC hwnd:HWND,flag:BOOL
		
		LOCAL ps:PAINTSTRUCT
		LOCAL hdc:HDC
		LOCAL hMemDC:HDC
		LOCAL rect:RECT
				
				invoke GetClientRect,hwnd,addr rect
				invoke GetDC,hwnd
				mov hdc,eax
				invoke FillRect,hdc,addr rect,COLOR_WINDOWTEXT
				invoke CreateCompatibleDC,hdc
				mov hMemDC,eax
				
				.if flag == TRUE
						
					invoke SelectObject,hMemDC,hBmp
					
				.elseif flag == FALSE
						
					invoke SelectObject,hMemDC,hBmp2
					
				.endif
				
				invoke GetClientRect,hwnd,addr rect
				invoke BitBlt,hdc,5,5,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY
				invoke DeleteDC,hMemDC
				
		
	ret
UpdateBitmap ENDP

LoadText PROC hMorse:DWORD,hEdit:HWND
	
		LOCAL txtSize :DWORD
		LOCAL pszBuff :DWORD
		LOCAL chrBuff :DWORD
		
			invoke GetWindowTextLength,hEdit
			mov txtSize,eax
			
			.if eax != NULL
					
				invoke GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,txtSize - 1
				mov pszBuff,eax
				invoke GlobalLock,pszBuff
				invoke GetWindowText,hEdit,pszBuff,txtSize - 1
				
				xor ecx,ecx
				mov ebx,pszBuff
				@@:
				xor eax,eax
				mov al,byte ptr [ebx]
				mov chrBuff,eax
				push ecx
				invoke PlayCode,chrBuff,p,tone,short_sound,long_sound
				pop ecx
				cmp ecx,txtSize
				je @F
				inc ecx
				inc ebx
				mov chrBuff,NULL
				jmp @B
				@@:
				
				invoke GlobalUnlock,pszBuff
				invoke GlobalFree,pszBuff
				
			.endif
	ret
LoadText ENDP

END DllMain
